<?php

class xItem {
  var $xTitle;
  var $xLink;
  var $xDescription;
}

// general vars
$sTitle = "";
$sLink = "";
$sDescription = "";
$arItems = array();
$itemCount = 0;

// ********* Start User-Defined Vars ************
// rss url goes here
if(!isset($uFile) || ($uFile=="")){
	$uFile = "http://www.wirelessdevnet.com/wirelessnews/rss/dailynews.rss";
}
// descriptions (true or false) goes here
$bDesc = true;
// ********* End User-Defined Vars **************

function startElement($parser, $name, $attrs) {
  global $curTag;

  $curTag .= "^$name";

}

function endElement($parser, $name) {
  global $curTag;

  $caret_pos = strrpos($curTag,'^');

  $curTag = substr($curTag,0,$caret_pos);

}

function characterData($parser, $data) { global $curTag; // get the Channel information first
  global $sTitle, $sLink, $sDescription;  
  $titleKey = "^RSS^CHANNEL^TITLE";
  $linkKey = "^RSS^CHANNEL^LINK";
  $descKey = "^RSS^CHANNEL^DESCRIPTION";
  if ($curTag == $titleKey) {
    $sTitle = $data;
  }
  elseif ($curTag == $linkKey) {
    $sLink = $data;
  }
  elseif ($curTag == $descKey) {
    $sDescription = $data;
	//	echo $sDescription;
	// This is the channel description
  }

  // now get the items 
  global $arItems, $itemCount,$titleCount;
  $itemTitleKey = "^RSS^CHANNEL^ITEM^TITLE";
  $itemLinkKey = "^RSS^CHANNEL^ITEM^LINK";
  $itemDescKey = "^RSS^CHANNEL^ITEM^DESCRIPTION";
	// Rescue the long lost ampersands!
  $data=str_replace("[AMPERSAND]","&",$data,0);
  if ($curTag == $itemTitleKey) {
    // make new xItem    
    if($titleCount>$itemCount){ $itemCount++; }
    $arItems[$itemCount] = new xItem();     
    // set new item object's properties    
	
    $titleCount++;

    $arItems[$itemCount]->xTitle = $data;
	//		echo "***".$data."***$itemCount $titleCount***\n";
	//	echo "***".$arItems[$itemCount]->xTitle."***\n";
  }
  elseif ($curTag == $itemLinkKey) {
    $arItems[$itemCount]->xLink = $data;
  }
  elseif ($curTag == $itemDescKey) {
    $arItems[$itemCount]->xDescription = $data;
	//	echo "*** ".$data."***"; // it seems that the & cutting it into bits!...
    	// increment item counter
    $itemCount++;
  }
}

// main loop
$xml_parser = xml_parser_create();
xml_set_element_handler($xml_parser, "startElement", "endElement");
xml_set_character_data_handler($xml_parser, "characterData");
if (!($fp = fopen($uFile,"r"))) {
  die ("could not open RSS $uFile for input");
}
while ($data = fread($fp, 4096)) {

  // What's the deal with the ampersand thing? Well, for some reason this parser barfs on ampersands. I dunno.
  // So I chose to just replace it and then replace it back after parsing
  // And \ns seem to confuse the living metaphor out of the parser... we can deal with that.
  $data=str_replace("\n","",$data,0); 
  $data=str_replace("&","[AMPERSAND]",$data,0);
  if (!xml_parse($xml_parser, $data, feof($fp))) {
    die(sprintf("XML error: %s at line %d", xml_error_string(xml_get_error_code($xml_parser)), xml_get_current_line_number($xml_parser)));
  }
}
xml_parser_free($xml_parser);


// write out the items
?>
<table width="70%" align="center">
<tbody>
<tr><td class="titlebar">
<a href = "<?php echo($sLink); ?>"><?php echo($sTitle); ?></a>
</td></tr>
<?php
//echo "count is ".count($arItems);
for ($i=0;$i<count($arItems);$i++) {
  $txItem = $arItems[$i];
        //print_r($txItem);
	if($txItem->xTitle!=""){
	   echo "<tr><td class=\"grid\"><a href=\"";
	   echo($txItem->xLink);
           echo "\">";
	   echo($txItem->xTitle); 
	   echo "</a>";
	   echo "</td>";
	   echo "</tr>";
	}
	if ($bDesc) {
		echo "<tr><td>";
		echo ($txItem->xDescription); 

		echo "</td></tr>";
	}
}
?>
</tbody>
</table>
